# MyModule Migrations

This module imports the XML data.

## Source data

The source data was delivered as XML files.

The following files are currently used in the import.

Articles and related data (taxonomy / paragraphs etc):
- articles.xml
- components.xml

Users:
- users.xml

## Location
To run the migrations, the module currently expect the migration source data
to be in the folder:

 _/tmp/migration_data/_ 
 
 eg. _/tmp/migration_data/articles.xml_.

## Available migrations

The following migrations are available, they run in the described order because of dependencies between them:
1. file_image: Imports all images as file entities.
2. media_image: Creates a media entity of type image for each file.
3. node_article: Imports all articles as nodes.
4. paragraph_component: Imports all relations between articles and components as paragraphs.
5. taxonomy_category: Imports all categories as taxonomy terms.
6. user: Imports all user.


## Start migrations

Migrations can be run with drush only. Use the command below to run all migrations. The --update flag is need to make
sure the imported entities are updated when a migration runs a second time.

```
drush mi --all --update --feedback="1000 items"
```

Run a single migration:

```
drush mi [migration name, eg. node_article, user etc] --update --feedback="1000 items"
drush mi node_article --update --feedback="1000 items"
drush mi users --update --feedback="1000 items"
```

## Rollback migrations

Migrations can be rolled back with drush only.

```
drush mr --all
```

## Reset migration status

If a migration fails for some reason (timeout, memory limit, XML error, database gone away, etc.) a running migration
could get stuck in a '_Importing_' status. This means that this migration will be skipped if you start another import.
To make sure all migration run again a next time, reset the status of a 'stuck' migration with the following command:

```
drush mrs [migration name, eg. node_article, user etc]
drush mrs node_article
drush mrs user
```

To see all statuses of the migrations use the following command:

```
drush ms
```
