<?php

namespace Drupal\mymodule_migration\Plugin\migrate\source;

use Drupal\migrate\Plugin\migrate\source\EmbeddedDataSource;
use Drupal\migrate\Plugin\MigrationInterface;

/**
 * Source plugin for ingredient taxonomy terms.
 *
 * @MigrateSource(
 *   id = "taxonomy_ingredient"
 * )
 */
class MyModuleMigrationTaxonomyIngredient extends EmbeddedDataSource {

  /**
   * {@inheritdoc}
   */
  public function __construct(array $configuration, $plugin_id, $plugin_definition, MigrationInterface $migration) {
    $configuration['data_rows'] = \Drupal::service('mymodule_migration.xml')->getIngredients();
    $configuration['ids'] = [
      'id' => [
        'type' => 'integer',
      ],
    ];
    parent::__construct($configuration, $plugin_id, $plugin_definition, $migration);
  }

}
